<?php
/**
 * Fernando Soares Social Buttons
 * @version	1.5.4, Dezembro/2014 07/12/2014
 * @author Fernando Soares ( www.fernandosoares.com.br )
 * @package Joomla 1.5 ~ 2.5
 * @Copyright 	(c) 2011-2014 Fernando Soares
 * @license	GNU/GPL 2.0 http://www.gnu.org/licenses/gpl-2.0.html
 *
 * Based in VagrantWeb Social Buttons by Carter McLaughlin <carter@vagrantweb.ca>
**/

// no direct access
defined( '_JEXEC' ) or  die('Restricted access');

jimport( 'joomla.plugin.plugin' );

class plgContentFSoares_SocialButtons extends JPlugin
{

	// Constructor
	function plgContentFSoares_SocialButtons( &$subject, $params )
	{
		parent::__construct( $subject, $params );
	}

	// Joomla! 1.5
	function onPrepareContent(&$row, &$params, $page = 0){
		$this->renderSocialButtons($row, $params, $page = 0);
	}

	// Joomla! 1.6/1.7/2.5
	function onContentPrepare($context, &$row, &$params, $page = 0){
		jimport('joomla.html.parameter');
		
		if(JRequest::getCmd("view") == "category" || JRequest::getCmd("view") == "featured" ) {
            $articleData = $this->getArticle($row);
            $row->title  = JArrayHelper::getValue($articleData,'title');
        }
		
		$this->renderSocialButtons($row, $params, $page = 0);
	}

	// Main function to render buttons
	function renderSocialButtons( &$row, &$params, $page = 0 )
	{
//		global $mainframe;
		// load plugin parameters
		$plugin =& JPluginHelper::getPlugin( 'content', 'fsoares_socialbuttons' );
		$pluginParams = new JParameter( $plugin->params );
		
		if(!$pluginParams->get( 'front', 1 ) && (JRequest::getVar('view') == 'frontpage' || JRequest::getVar('view') == 'featured')) return;
		if(!$pluginParams->get( 'where', 1 ) && JRequest::getVar('view') != 'article' && JRequest::getVar('option','') != 'com_virtuemart' && JRequest::getVar('option','') != 'com_docman') return;
		
		$cat_to_show = array_filter(explode(",", $pluginParams->get( 'jcat_to_show' ))); 
		$jcat_now = array_filter(explode(":", JRequest::getVar('catid')));
		if(JRequest::getVar('view') == 'article' && !empty($cat_to_show) && !in_array($jcat_now[0], $cat_to_show)) return;
		
		if(JRequest::getVar('option','') == 'com_virtuemart'){
			if (!$pluginParams->get( 'vmshow', 1 )){
				return;
			}elseif(JRequest::getVar('page') != null && JRequest::getVar('page') != 'shop.product_details'){
				return;
			}elseif(JRequest::getVar('view') != null && JRequest::getVar('view') != 'productdetails'){
				return;
			}
		}

		if(JRequest::getVar('option','') == 'com_docman' && (!$pluginParams->get( 'dmshow', 1 ) || JRequest::getVar('task','') != 'doc_details')) return;

		$link1 =& JURI::getInstance();
        $link = $link1->toString();
				
		if(JRequest::getVar('option','') == 'com_virtuemart'){
			$title = "Sugestão de Produto interessante";
		}elseif(JRequest::getVar('option','') == 'com_docman'){
			$title = "Sugestão de Download interessante";
		}else{
			$title = htmlspecialchars($row->title);
		}

		$plusone = '';  $like = '';  $retweet = '';  $linkedin = '';

		$position = $pluginParams->get( 'position', 0 );
		$float = $pluginParams->get( 'float', 'left' );
		$backcolor = $pluginParams->get( 'backcolor', 'transparent' );
		if($pluginParams->get( 'count', 'horizontal' ) == 'horizontal'){
			$g1count = 'medium';
			$fbcount = 'button_count';
			$incount = 'data-counter="right"';
			$width = '110';
			$height = '20';
		} elseif($pluginParams->get( 'count', 'horizontal' ) == 'vertical'){ 
			$g1count = 'tall';
			$fbcount = 'box_count';
			$incount = 'data-counter="top"';
			$width = '55';
			$height = '65';
		} else {
			$g1count = 'medium';
			$fbcount = 'button_count';
			$incount = '';
			$width = '55';
			$height = '20';
		}
		
		if($pluginParams->get( 'plusone', 1 )) $plusone = '<div class="fssb_bt" style="margin-left:2px; float:'.$float.'; height:'.$height.'px; width:'.$width.'px;"><script type="text/javascript" src="http://apis.google.com/js/plusone.js"> {lang: "pt-BR"} </script> <g:plusone size="'.$g1count.'"></g:plusone></div>';
		
		if($pluginParams->get( 'like', 1 )) $like = '<div class="fssb_bt" style="margin-left:2px; float:'.$float.'; height:'.$height.'px; width:'.$width.'px;"><iframe src="http://www.facebook.com/plugins/like.php?href=' . urlencode($link) . '&amp;layout='.$fbcount.'&amp;width='.$width.'&amp;show_faces=false&amp;action='.$pluginParams->get( 'like_verb', 'like' ).'&amp;colorscheme='.$pluginParams->get( 'like_color_scheme', 'light' ).'&amp;height" scrolling="no" frameborder="0" style="border:none; overflow:hidden; width:'.$width.'px; height:'.$height.'px;" allowTransparency="true"></iframe></div>';
				
		if($pluginParams->get( 'retweet', 1 )) $retweet = '<div class="fssb_bt" style="margin-left:2px; float:'.$float.'; height:'.$height.'px; width:'.$width.'px;"><a href="http://twitter.com/share?url=' . urlencode($link) . '" class="twitter-share-button" data-text="'.$title.':" data-count="'.$pluginParams->get( 'count', 'horizontal' ).'" data-via="'.$pluginParams->get( 'twitter_account', '' ).'" data-related="'.$pluginParams->get( 'twitter_account2', 'fernando_soares' ).'">Tweet</a><script type="text/javascript" src="http://platform.twitter.com/widgets.js"></script></div>';
		
		if($pluginParams->get( 'linkedin', 0 ))	$linkedin = '<div class="fssb_bt" style="margin-left:2px; float:'.$float.'; height:'.$height.'px; width:'.$width.'px;"><script type="text/javascript" src="http://platform.linkedin.com/in.js"></script><script type="in/share" data-url='.$link.' '. $incount . '></script></div>';

		$dos = $plusone . $retweet . $linkedin . $like;

		if($position==0){ 	
			$row->text =  $row->text.'<div class="fssb" style="margin-top:10px;padding: 5px;background: none repeat scroll 0 0 '.$backcolor.';border: 1px none;">'.$dos.'<div style="clear:both;"></div></div>';
		}else if($position==1){
			$row->text =  '<div class="fssb" style="padding: 5px;background: none repeat scroll 0 0 '.$backcolor.';border: 1px none;">'.$dos.'<div style="clear:both;"></div></div>'.$row->text.'';
		}else{
			$row->text =  '<div class="fssb" style="padding: 5px;background: none repeat scroll 0 0 '.$backcolor.';border: 1px none;">'.$dos.'<div style="clear:both;"></div></div>'.$row->text.'<div class="fssb" style="margin-top:10px;padding: 5px;background: none repeat scroll 0 0 '.$backcolor.';border: 1px none;">'.$dos.'<div style="clear:both;"></div></div>';
		}
	}

	/**
     * 
     * Load an information about article, if missing, on the view 'category' and 'featured'
     * @param object $article
     */
    private function getArticle(&$article) {
        
        $db = JFactory::getDbo();
        
        $query = "
            SELECT 
                `#__content`.`id`,
                `#__content`.`catid`,
                `#__content`.`alias`,
                `#__content`.`title`,
                `#__categories`.`alias` as category_alias
            FROM
                `#__content`
            INNER JOIN
                `#__categories`
            ON
                `#__content`.`catid`=`#__categories`.`id`
            WHERE
                `#__content`.`introtext` = " . $db->quote($article->text); 
        
        $db->setQuery($query);
       
        try {
            $result = $db->loadAssoc();
        } catch(Exception $e) {
            JError::raiseError(500, "System error!", $e->getMessage());
        }
        
        if(!empty($result)) {
            $result['slug']     = $result['alias'] ? $result['id'].':'.$result['alias'] : $result['id'];
            $result['catslug']  = $result['category_alias'] ? $result['catid'].':'.$result['category_alias'] : $result['catid'];
        }
        
        return $result;
    }
}
?>